$ontext

                                Filename : calibGAMS.gms
                                Author   : Josef Kallrath
                                           Scientific Consulting
                                           Am Mahlstein 8
                                           67273 Weisenheim am Berg
                                           Germany
                                E-Mail   : josef.kallrath@web.de
                                Release  : Aug 02, 2017
                                Revised  : Aug 06, 2017 - 16:44

   This calibration test contains 6 solve statements with deterministic time
   limits to be specified in compileD.par

   The MILP problem stems from MIPLIB, and has been provided by
   Michael Bussieck, GAMS GmbH, Cologne, Germany.

   This calibration tool needs about 300 seconds on a 3 GHz laptop with
   16 GByte RAM.

   The output is accumulated to the calibration.txt

   If this file does not exist, it is created automatically with the
   system characterics written to the file. After this, a line is added
   for each run.

$offtext

* the CPU time limit (deterministic in ticks) for solve statement 2 (50000)
$  if not set CPUdet1 $ setglobal CPUdet1 5000
$  if set     CPUdet1 $ setglobal CPUdet1 %CPUdet1%
$  drop CPUdet1

* the CPU time limit (deterministic in ticks) for solve statement 2 (15000)
$  if not set CPUdet2 $ setglobal CPUdet2 1000
$  if set     CPUdet2 $ setglobal CPUdet2 %CPUdet2%
$  drop CPUdet2

   Scalars CPUsolve  accumulated CPU time spend in the solve statement / 0 /
           CPUsolver accumulated CPU time used for solver only / 0 /
           CPUslack  elapsed - compilation - execution - solver /0/ ;

* =============================================================================


* mps2gms 1.1      Feb 14, 2009 23.0.2 WIN 7053.9411 VIS x86/MS Windows
*
* MPS Input File = core4872-1529.mps
*
* line        1 NAME           core4872-1529
* line        2 ROWS
* line        3  N  obj
* line     4879 COLUMNS
* line   248300 RHS
* line   248301     rhs       UB                    10000000000
* line   253176 BOUNDS
* line   253177  UP bnd       X1                              1
* line   277822 ENDATA
*
* Number of MPS rows    =      4876 (N:1 L:2 G:4873 E:0)
* Number of MPS columns =     24656 (C:11 I:24645)
* Number of MPS coefs   =    243418 (N:24656 L:42520 G:176242 E:0)
* Number of MPS Qs      =         0 (empty rows:0)
* Number of MPS cones   =         0
* Number of MPS errors  =         0


sets i      all rows in MPS order
     ig(i)  greater-than-or equal rows
     il(i)  less-than-or equal rows
     ie(i)  equality rows
     ir(i)  ranged rows
     ik(i)  cones;

equations eobj   objective function
          eg(i)  greater-than-or equal equs
          el(i)  less-than-or equal equs
          ee(i)  equality equs
          er(i)  ranged equs
          ek(ik) cone equs;

sets j        all columns in MPS order
     jc (j)   continuous columns
     jb (j)   binary columns
     ji (j)   integer columns
     jsc(j)   semi-continuous columns
     jsi(j)   semi-integer columns
     s        sos sets
     js1(s,j) sos 1 columns
     js2(s,j) sos 2 columns;


         variables obj        objective variable
positive variables xc (j)     continuous variables
                   r  (i)     ranged row variables
binary   variables xb (j)     binary variables
integer  variables xi (j)     integer variables
semicont variables xsc(j)     semi-continuous variables
semiint  variables xsi(j)     semi-integer variables
sos1     variables xs1(s,j)   sos 1 variables
sos2     variables xs2(s,j)   sos 2 variables;


parameters  c(j)        objective coefs
            cobj        objective constant
            b(i)        right hand sides
            ac (i,jc)   matrix coefs: continuous variables
            ab (i,jb)   matrix coefs: binary variables
            ai (i,ji)   matrix coefs: integer variables
            asc(i,jsc)  matrix coefs: semi-continuous variables
            asi(i,jsi)  matrix coefs: semi-integer variables
            as1(i,s,j)  matrix coefs: sos 1 variables
            as2(i,s,j)  matrix coefs: sos 2 variables;


eobj.. obj =e= sum(jc,       c(jc  )*xc (jc ))
             + sum(jb,       c(jb  )*xb (jb ))
             + sum(ji,       c(ji  )*xi (ji ))
             + sum(jsc,      c(jsc )*xsc(jsc))
             + sum(jsi,      c(jsi )*xsi(jsi))
             + sum(js1(s,j), c(j)*xs1(js1))
             + sum(js2(s,j), c(j)*xs2(js2)) + cobj;

eg(ig)..       sum(jc,  ac (ig,jc )*xc (jc ))
             + sum(jb,  ab (ig,jb )*xb (jb ))
             + sum(ji,  ai (ig,ji )*xi (ji ))
             + sum(jsc, asc(ig,jsc)*xsc(jsc))
             + sum(jsi, asi(ig,jsi)*xsi(jsi))
             + sum(js1, as1(ig,js1)*xs1(js1))
             + sum(js2, as2(ig,js2)*xs2(js2)) =g= b(ig);

el(il)..       sum(jc,  ac (il,jc )*xc (jc ))
             + sum(jb,  ab (il,jb )*xb (jb ))
             + sum(ji,  ai (il,ji )*xi (ji ))
             + sum(jsc, asc(il,jsc)*xsc(jsc))
             + sum(jsi, asi(il,jsi)*xsi(jsi))
             + sum(js1, as1(il,js1)*xs1(js1))
             + sum(js2, as2(il,js2)*xs2(js2)) =l= b(il);

ee(ie)..       sum(jc,  ac (ie,jc )*xc (jc ))
             + sum(jb,  ab (ie,jb )*xb (jb ))
             + sum(ji,  ai (ie,ji )*xi (ji ))
             + sum(jsc, asc(ie,jsc)*xsc(jsc))
             + sum(jsi, asi(ie,jsi)*xsi(jsi))
             + sum(js1, as1(ie,js1)*xs1(js1))
             + sum(js2, as2(ie,js2)*xs2(js2)) =e= b(ie);

er(ir)..       sum(jc,  ac (ir,jc )*xc (jc ))
             + sum(jb,  ab (ir,jb )*xb (jb ))
             + sum(ji,  ai (ir,ji )*xi (ji ))
             + sum(jsc, asc(ir,jsc)*xsc(jsc))
             + sum(jsi, asi(ir,jsi)*xsi(jsi))
             + sum(js1, as1(ir,js1)*xs1(js1))
             + sum(js2, as2(ir,js2)*xs2(js2)) =e= r(ir);

ek(ik)..       sum(jc,  ac (ik,jc )*xc (jc )) =c= 0;

model m / all /;


set mps2gms; parameter mps2gmsstats(mps2gms);

$gdxin c.gdx
$load i j mps2gms s mps2gmsstats
$load ig il ie ir ik
$load jc jb ji jsc jsi js1 js2
$load cobj c b
$load ac ab ai asc asi as1 as2
$load xc xb xi xsc xsi xs1 xs2 r

$gdxin

option limcol=0,limrow=0,solprint=off,optcr=0;

$onecho > cplex.opt
mipstart 1
startalg 4
dettilim %CPUdet1%
$offecho
m.optFile = 1;
solve m using mip minimizing obj;
CPUsolve  = CPUsolve  + m.etSolve  ;
CPUsolver = CPUsolver + m.etSolver ;

* fix and optimize
set it / i1*i5 /;
m.optFile = 2;
$onecho > cplex.op2
mipstart 1
dettilim %CPUdet2%
$offecho
loop(it,
  xb.fx(jb)$(uniform(0,1)<0.4) = round(xb.l(jb));
  solve m using mip minimizing obj;
  CPUsolve  = CPUsolve  + m.etSolve  ;
  CPUsolver = CPUsolver + m.etSolver ;
  xb.lo(jb) = 0; xb.up(jb) = 1;
);

* Last solve with unfixed
m.optFile = 1;
solve m using mip minimizing obj;
CPUsolve  = CPUsolve  + m.etSolve  ;
CPUsolver = CPUsolver + m.etSolver ;

   CPUslack = timeElapsed - TimeComp
                          - TimeExec
                          - CPUsolver ;





   File SummaryOut / summary.csv / ; put SummaryOut ; SummaryOut.pc = 5 ;

   Put SummaryOut /
       ' ============================================================ ' /
       '               S Y S T E M   I N F O R M A T I O N '            /
       ' ============================================================ ' //

       ' GAMS file used: %System.ifile% '                               /
       ' Operation system: %System.filesys%  %System.date% at %System.time%' /
       ' %System.gstring%'                    ///

       ' ============================================================ ' /
       '            S U M M A R Y   -   K E Y    R E S U L T S        ' /
       ' ============================================================ ' //


       ' time (sec) used for compilation        : ' TimeComp /
       ' time (sec) for execution               : ' TimeExec /
       ' time (sec) used by the solve statement : ' CPUsolve /
       ' time (sec) used by the solver alone    : ' CPUsolver /
       ' time (sec) used by GAMS & solver       : ' timeElapsed /
       ' time (sec) slack                       : ' CPUslack //

   putclose ;

$ IFTHEN EXIST calibration.txt

   FILE calib / calibration.txt / ;  calib.ap = 1 ;

$ ELSE

   FILE calib / calibration.txt / ;

  Put calib /
   ' ============================================================ ' /
   '               S Y S T E M   I N F O R M A T I O N '            /
   ' ============================================================ ' //

   ' GAMS file used: %System.ifile% '                               /
   ' Operation system: %System.filesys%  %System.date% at %System.time%' /
   ' %System.gstring%'                    //

   ' Date         Time      comp    exec   solver  elapsed  slack ' /
   ' ============================================================ ' //

$ ENDIF

  Put calib ' %System.date% at %System.time%'
      TimeComp:7:2
      TimeExec:8:2
      CPUsolver:9:2
      timeElapsed:9:2
      CPUslack:7:2 / ;

  putclose ;

  execute 'del cp*.op*' ;

* ============================== end of calibGAMS.gms =========================

