
      @echo off

REM   Tool: Calibrating a computer to GAMS and CPLEX
REM
REM                  \runCalib.BAT      Version :  Aug 06, 2017

REM   Developed for "Public"  by Prof. Dr. Josef Kallrath 
REM                              Scientific Consultant
REM                              Am Mahlstein 8
REM                            D-67273 Weisenheim am Berg
REM                              Germany
REM                     e-mail: josef.kallrath@t-online.de
REM                     e-mail: josef.kallrath@web.de
REM

REM *-------------------------------------------------------------
REM *  Description
REM *-------------------------------------------------------------

REM   This DOS command procedure starts the GAMS calibration tool.
REM
REM   This calibration test contains 6 solve statements with deterministic time
REM   limits to be specified in compileD.par

REM   The MILP problem stems from MIPLIB, and has been provided by
REM   Michael Bussieck, GAMS GmbH, Cologne, Germany.

REM   This calibration tool needs about 300 seconds on a 3 GHz laptop with
REM   16 GByte RAM.

REM   The output is accumulated to the calibration.txt

REM   If this file does not exist, it is created automatically with the
REM   system characterics written to the file. After this, a line is added
REM   for each run.


REM *-------------------------------------------------------------
REM *  clean the directory "CalibrationGAMS" 
REM *-------------------------------------------------------------

REM   delete old files 
       call clean.bat 


REM *-------------------------------------------------------------
REM *  start the GAMS file
REM *-------------------------------------------------------------

REM   generic GAMS call 
       gams dummy pf=startGAMS.cfg
:      start /wait /min /high  gams dummy pf=startGAMS.cfg

       goto EXIT 


REM *-------------------------------------------------------------
REM *  end of batch file and EXIT
REM *-------------------------------------------------------------

     :EXIT

REM ---------------------  end-of-file:  runCalib.bat -----------------------

